﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Collections.ObjectModel;

namespace test
{
    public partial class frmSnapfeaturelayer : Form
    {
        public frmSnapfeaturelayer()
        {
            InitializeComponent();
        }

        private void frmSnapfeaturelayer_Load(object sender, EventArgs e)
        {
            LoadDefaultMap();
            PlotLinePoint();
        }
        private void LoadDefaultMap()
        {

            wfMap.Overlays.Clear();
            wfMap.ZoomLevelSnapping = ZoomLevelSnappingMode.None;
            
            wfMap.Overlays.Clear();
            wfMap.MapUnit = GeographyUnit.DecimalDegree;
            

            GraticuleAdornmentLayer graticuleAdornmentLayer = new GraticuleAdornmentLayer();
            graticuleAdornmentLayer.Close();
            graticuleAdornmentLayer.Open();
            graticuleAdornmentLayer.GraticuleLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Silver, 0.001F, LineDashStyle.Dash, false);
            wfMap.AdornmentOverlay.Layers.Add(graticuleAdornmentLayer);
            wfMap.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);
            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(Application.StartupPath + @"\Data\Countries02.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            LayerOverlay coverlay = new LayerOverlay();
            coverlay.Layers.Add("WorldLayer", worldLayer);
            
            wfMap.Overlays.Add(coverlay);
           
          
          
        }
        private void PlotLinePoint()
        {
            InMemoryFeatureLayer imline = new InMemoryFeatureLayer();
            imline.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Blue,1,false);
            imline.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.City1;
            imline.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                       
            Feature fline1 = new Feature(BaseShape.CreateShapeFromWellKnownData("LINESTRING(73 23,74 25,75 25)"));
            //Feature fline2 = new Feature(BaseShape.CreateShapeFromWellKnownData("LINESTRING(74 25,75 25)"));
            Feature fp1 = new Feature(BaseShape.CreateShapeFromWellKnownData("MULTIPOINT(73 23,74 25)"));
            //Feature fp2 = new Feature(BaseShape.CreateShapeFromWellKnownData("MULTIPOINT(74 25)"));

            imline.InternalFeatures.Add(fline1);
          //  imline.InternalFeatures.Add(fline2);
           // imline.InternalFeatures.Add(fp1);
            //imline.InternalFeatures.Add(fp2);

            LayerOverlay TestOverlay = new LayerOverlay();
            TestOverlay.Layers.Add("Route", imline);
            wfMap.Overlays.Add(TestOverlay);

            InMemoryFeatureLayer imline1 = new InMemoryFeatureLayer();
            imline1.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Copper, 1, false);
            imline1.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.City2;
            imline1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            Feature fline11 = new Feature(BaseShape.CreateShapeFromWellKnownData("LINESTRING(73 25,75 25)"));
            Feature fp11 = new Feature(BaseShape.CreateShapeFromWellKnownData("MULTIPOINT(73 25,75 25)"));
            //Feature fp21 = new Feature(BaseShape.CreateShapeFromWellKnownData("MULTIPOINT(75 25)"));


           imline1.InternalFeatures.Add(fp11);
           // imline1.InternalFeatures.Add(fline11);
          
           // imline1.InternalFeatures.Add(fp21);

            LayerOverlay TestOverlay1 = new LayerOverlay();
            TestOverlay1.Layers.Add("Seg", imline1);
            wfMap.Overlays.Add(TestOverlay1);
            wfMap.Refresh();


        }
        SnapToLayerEditInteractiveOverlay s = new SnapToLayerEditInteractiveOverlay();
        TrackInteractiveOverlay s1 = new TrackInteractiveOverlay();
        private void btnEdit_Click(object sender, EventArgs e)
        {
            
            wfMap.FindFeatureLayer("Route").FeatureSource.Open();

            InMemoryFeatureLayer linefeature = (InMemoryFeatureLayer)wfMap.FindFeatureLayer("Seg");
            linefeature.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Railway3;
            linefeature.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.City2;

            Collection<Feature> RF = wfMap.FindFeatureLayer("Route").FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);
            foreach (Feature feature in RF)
            {
                if (feature.GetShape().ToString() != "ThinkGeo.MapSuite.Core.MultipointShape")
                    s.EditShapesLayer.InternalFeatures.Add(feature);
            }

            s.ControlPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.StandardColors.PaleGoldenrod), new GeoPen(GeoColor.StandardColors.Black), 5);

            //Sets the PointStyle for the dragged control points.
            s.DraggedControlPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.StandardColors.Red), new GeoPen(GeoColor.StandardColors.Orange, 2), 10);


            s.ToSnapInMemoryFeatureLayer = linefeature;
            

            s.ToleranceType = ToleranceCoordinates.Screen;
            s.Tolerance = 15;
         
            s.CalculateAllControlPoints();

          
            vMove = false;


            s.VertexAdded += new EventHandler<VertexAddedEditInteractiveOverlayEventArgs>(VertexAdded);
            s.VertexRemoved += new EventHandler<VertexRemovedEditInteractiveOverlayEventArgs>(VertexRemoved);

            s.MapMouseClick += new EventHandler<MapMouseClickInteractiveOverlayEventArgs>(EventHandlingMethod);
        
            
            wfMap.EditOverlay = s;
            wfMap.Refresh();
        }
        Boolean vMove = false,vAdded = false,vRemoved= false;
        private void VertexMoved(object sender,EventArgs e)
        {
            vMove = true;
            
         
        }
        private void VertexAdded(object sender, EventArgs e)
        {
            vAdded = true;
        
        }
        private void VertexRemoved(object sender, EventArgs e)
        {
            
            vRemoved = true;
          
        }
        private void EventHandlingMethod(object sender,EventArgs e)
        {
            try
            {
               
              //
     
            }
            catch (Exception er)
            {
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                InMemoryFeatureLayer imtest = new InMemoryFeatureLayer();
                imtest.FeatureSource.Open();
                imtest.FeatureSource.BeginTransaction();
                foreach (Feature feature in wfMap.EditOverlay.EditShapesLayer.InternalFeatures)
                {
                    imtest.FeatureSource.AddFeature(feature);
                    string test = feature.GetWellKnownText().ToString();
                }
                imtest.FeatureSource.CommitTransaction();
                LineShape newRoute = new LineShape(imtest.InternalFeatures[0].GetWellKnownBinary());
            }
            catch (Exception er)
            {
            }
        }

       

    }
}
